package jp.kambayashi.gl04;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.nio.FloatBuffer;
import java.nio.IntBuffer;

import javax.microedition.khronos.egl.EGL10;
import javax.microedition.khronos.egl.EGLConfig;
import javax.microedition.khronos.egl.EGLContext;
import javax.microedition.khronos.egl.EGLDisplay;
import javax.microedition.khronos.egl.EGLSurface;
import javax.microedition.khronos.opengles.GL10;

import android.content.res.Resources;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.opengl.GLU;
import android.util.Log;
import android.view.View;

public class GLThread extends Thread {
	//IuWFNgʎq
	private String mName;
	//ʊǗIuWFNg
	private GLView mView;
	//stO
	private boolean mDone;
	//`wp[
	private Renderer mRenderer;

	//ES_OReLXg
	private EGLContext mEglContext;
	//ESfBXvCRlNV
	private EGLDisplay mEglDisplay;
	//EST[tFCX
	private EGLSurface mEglSurface;
	//ESRtBO
	private EGLConfig mEglConfig;
	
	/**
	 * RXgN^
	 * @param view	
	 */
	public GLThread(GLView view){
		mView = view;
		mName = "GLThread";
		mDone = false;
		mRenderer = new Renderer();
	}

	/**
	 * XbhX^[g
	 */
	@Override
	public void run() {
		//OpenGL ES̏
		if( !initGLES() ){
			Log.e(mName, "OpenGL ESs");
			mDone = true;
		}
			
		GL10 gl = (GL10)mEglContext.getGL();
		
		//eNX`[h
		if( !mRenderer.loadTexture(gl, mView, R.drawable.texture1) ){
			Log.e(mName, "eNX`ǂݍݎs");
			mDone = true;
		}

		//Ivł܂ŌJԂ
		while(!mDone){
			//`
			drawFrame(gl);
		}
		
		//OpenGL ES̕Еt
		endGLES();
	}
	
	/**
	 * `
	 * 
	 * @param gl	OpenGLnh
	 */
	private void drawFrame( GL10 gl ){
		//r[|[gs(EBhEւ̏o͗̈)ݒ
		gl.glViewport(0,0,mView.getWidth(),mView.getHeight());
        
		{
			//ˉesݒ
			gl.glMatrixMode(GL10.GL_PROJECTION);
			gl.glLoadIdentity();
			//E(pAʂ̃AXyNgAߎ_A_)̐ݒ
			float aspect = (float)mView.getWidth() / (float)mView.getHeight();
			GLU.gluPerspective(gl, 45.0f, aspect, 0.1f, 10.0f);
		}
		
		{
			//fr[s̐ݒ
			gl.glMatrixMode(GL10.GL_MODELVIEW);
			//Pʍs
			gl.glLoadIdentity();
			//J̐ݒ
			GLU.gluLookAt(gl, 
					0.0f, 1.0f, 3.0f, //ʒu(_)
					0.0f, 0.0f, 0.0f, //߂ĂƂ
					0.0f, 1.0f, 0.0f); //Ă
		}
        
        
		//ʃNAJ[ݒ肵āAJ[obt@(wi)AZobt@NA
		gl.glClearColor(1.0f, 1.0f, 1.0f, 1.0f);
		gl.glClear(GL10.GL_COLOR_BUFFER_BIT | GL10.GL_DEPTH_BUFFER_BIT);
		
		//`
		mRenderer.draw(gl);
		
		//ʂɏo͂obt@̐؂ւ
		EGL10 egl = (EGL10)EGLContext.getEGL();
		egl.eglSwapBuffers(mEglDisplay, mEglSurface);
	}
	
	/**
	 * OpenGL ES
	 * 
	 * 
	 * @return	IȂ^AG[ȂU
	 */
	private boolean initGLES(){
		//GL ES샂W[擾 
		EGL10 egl = (EGL10)EGLContext.getEGL();
		
		{
			//fBXvCRlNV쐬
			mEglDisplay = egl.eglGetDisplay(EGL10.EGL_DEFAULT_DISPLAY);
			if( mEglDisplay == EGL10.EGL_NO_DISPLAY ){
				Log.e(mName, "fBXvCRlNV쐬s");
				return false;
			}
			
			//fBXvCRlNV
			int[] version = new int[2];
			if( !egl.eglInitialize(mEglDisplay, version) ){
				Log.e(mName, "fBXvCRlNVs");
				return false;
			}
			
			//OpenGLo[Wo
			Log.i(mName, "OpenGL ES " +	"Version[" + version[0] + "." + version[1] + "]" );
		}
		
		{
			//RtBOݒ
			int[] configSpec = {
				/*
				 * 2008/12/1 C
				 * ȉ̐ݒ肪@ł͎gȂ悤Ȃ̂ŃJbgB
				 * ͂̕ƁAT|[gĂݒ肪g(Iɐݒ肵ȂƋ@ˑŕς\?)B
				EGL10.EGL_ALPHA_SIZE, 8,	//At@`lF8rbg
				EGL10.EGL_RED_SIZE, 8,		//ԗvfF8rbg
				EGL10.EGL_GREEN_SIZE, 8,	//ΗvfF8rbg
				EGL10.EGL_BLUE_SIZE, 8,		//vfF8rbg
				*/
				EGL10.EGL_DEPTH_SIZE, 16,	//[xobt@F16rbg
				EGL10.EGL_NONE				//I[ɂEGL_NONE
			};
			EGLConfig[] configs = new EGLConfig[1];
			int[] numConfigs = new int[1];
			if( !egl.eglChooseConfig(mEglDisplay, configSpec, configs, 1, numConfigs) ){
				Log.e(mName, "RtBOݒ莸s");
				return false;
			}
			mEglConfig = configs[0];
		}
		
		{
			//_OReLXg쐬
			mEglContext = 
				egl.eglCreateContext(mEglDisplay, mEglConfig, EGL10.EGL_NO_CONTEXT, null);
			if( mEglContext == EGL10.EGL_NO_CONTEXT ){
				Log.e(mName, "_OReLXg쐬s");
				return false;
			}
		}
		
		{
			//T[tFCX쐬(Ƃŕ̂ŕʃ\bh)
			if( !createSurface() ){
				Log.e(mName, "T[tFCX쐬s");
				return false;
			}
		}
		
		return true;
	}
	
	/**
	 * T[tFCX쐬
	 * 
	 * T[tFCX쐬āA_OReLXgƌт
	 * 
	 * @return	IȂ^AG[ȂU
	 */
	private boolean createSurface(){
		EGL10 egl = (EGL10)EGLContext.getEGL();
		
		{
			//T[tFCX쐬
			mEglSurface = 
				egl.eglCreateWindowSurface(mEglDisplay, mEglConfig, mView.getHolder(), null);
			if( mEglSurface == EGL10.EGL_NO_SURFACE ){
				Log.e(mName, "T[tFCX쐬s");
				return false;
			}
		}
		
		{
			//T[tFCXƃ_OReLXgт
			if( !egl.eglMakeCurrent(mEglDisplay, mEglSurface, mEglSurface, mEglContext) ){
				Log.e(mName, "_OReLXgƂ̌тs");
				return false;
			}
		}
		
		return true;
	}
	
	/**
	 * OpenGL ESЕt
	 */
	private void endGLES(){
		EGL10 egl = (EGL10)EGLContext.getEGL();
		
		//T[tFCXj
		if( mEglSurface != null){
			//_OReLXgƂ̌т͉
			egl.eglMakeCurrent(mEglDisplay, EGL10.EGL_NO_SURFACE, EGL10.EGL_NO_SURFACE, EGL10.EGL_NO_CONTEXT);
			
			egl.eglDestroySurface(mEglDisplay, mEglSurface);
			mEglSurface = null;
		}
		
		//_OReLXgj
		if( mEglContext != null ){
			egl.eglDestroyContext(mEglDisplay, mEglContext);
			mEglContext = null;
		}
		
		//fBXvCRlNVj
		if( mEglDisplay != null){
			egl.eglTerminate(mEglDisplay);
			mEglDisplay = null;
		}
	}
	
	/**
	 * XbhIv
	 * 
	 * XbhɏIvoāA~̂҂
	 */
	public void RequestExitAndWait(){
		synchronized (this) {
			//Ivo
			mDone = true;
		}
		
		try{
			//XbhI҂
			join();
		}
		catch( InterruptedException ex ){
			Thread.currentThread().interrupt();
		}
	}
	
	/**
	 * `⏕NX
	 */
	class Renderer{
		//_obt@
		private FloatBuffer vertexBuffer;
		//eNX`Wobt@
		private FloatBuffer textureBuffer;
		//eNX`Ǘԍ
		private int textureNo;
		
		/**
		 * RXgN^
		 */
		public Renderer(){
			{
				//_obt@쐬
				//_x_\vfx4oCg̃TCỸobt@쐬
				ByteBuffer vb = ByteBuffer.allocateDirect(4 * 3 * 4);
				vb.order(ByteOrder.nativeOrder());	//rbOGfBAgGfBAɂ킹Ă
				vertexBuffer = vb.asFloatBuffer();
		
				//_f[^Œ_obt@쐬
				float[] vertices = {
						// X,Y,Z3vfŎlp`\4_
						-0.5f, -0.5f, 0.0f,		//W(0,0,0)𒆐Sɍ
						0.5f, -0.5f, 0.0f,		//		V			E
						-0.5f, 0.5f, 0.0f,		//		V			
						0.5f, 0.5f, 0.0f,		//		V			E
				};
				vertexBuffer.put(vertices);
				vertexBuffer.position(0);
			}
		
			{
				//eNX`obt@쐬
				//_x_\vfx4oCg̃TCỸobt@쐬
				ByteBuffer vb = ByteBuffer.allocateDirect(4 * 2 * 4);
				vb.order(ByteOrder.nativeOrder());	//rbOGfBAgGfBAɂ킹Ă
				textureBuffer = vb.asFloatBuffer();
		
				//eNX`_f[^ŃeNX`_obt@쐬
				float[] textureUV = {
						//Oq̎lp`̊e_ɑΉX,Y(S,TƂ)2vf̃eNX`W
						0.0f, 0.0f,				//eNX`̍
						1.0f, 0.0f,				//	V	@@E
						0.0f, 1.0f,				//	V	@@
						1.0f, 1.0f				//	V	@@E
				};
				textureBuffer.put(textureUV);
				textureBuffer.position(0);
			}
		}
		
		/**
		 * `
		 * @param gl	GLnh
		 */
		public void draw( GL10 gl ){
			//|SJ[ݒ
			gl.glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
			//_obt@@\ON
			gl.glEnableClientState(GL10.GL_VERTEX_ARRAY);
			gl.glEnableClientState(GL10.GL_TEXTURE_COORD_ARRAY);		//eNX`\Ƃ͂Kv
			//_obt@ݒ
			gl.glVertexPointer(3, GL10.GL_FLOAT, 0, vertexBuffer);
			//eNX`obt@ݒ
			gl.glTexCoordPointer(2, GL10.GL_FLOAT, 0, textureBuffer );
			//eNX`}bsOON
			gl.glEnable(GL10.GL_TEXTURE_2D);
			gl.glBindTexture(GL10.GL_TEXTURE_2D, textureNo);
			gl.glTexEnvf(GL10.GL_TEXTURE_ENV, GL10.GL_TEXTURE_ENV_MODE, GL10.GL_MODULATE);
			
			/*
			 * 2008/12/1 C
			 * GL_BLENDGL_ALPHA_TEST̕p͑ʖڂƂƂŕЕJbg
			 */
			//gl.glEnable( GL10.GL_ALPHA_TEST );
			//gl.glAlphaFunc(GL10.GL_NOTEQUAL, 0.0f );
			gl.glEnable( GL10.GL_BLEND );
			gl.glBlendFunc(GL10.GL_SRC_ALPHA, GL10.GL_ONE_MINUS_SRC_ALPHA );
			//`
			gl.glDrawArrays(GL10.GL_TRIANGLE_STRIP, 0, 4);
		}
		
		/**
		 * eNX`ǂݍ
		 * @param gl	OpenGLnh
		 * @param view	r[IuWFNg
		 * @param id	eNX`ID
		 * @return	ǂݍ߂^AsȂU
		 */
		public boolean loadTexture( GL10 gl, View view, int id ){
			//\[X擾
			Resources res = view.getContext().getResources();
			Bitmap bitmap = BitmapFactory.decodeResource(res, id);
			if( bitmap == null)
				return false;
			
			//rbg}bvsNZf[^擾
			int w = bitmap.getWidth(), h = bitmap.getHeight();
			int[] bitmapData = new int[ w * h ];
			//œǂݍ񂾂ƂɃeNX`̃At@`l0x000xFFȂƐǂݍ܂Ȃ?
			bitmap.getPixels(bitmapData, 0, w, 0, 0, w, h);	
			//SsNZ̐Ff[^̏ARGBABGRɕϊ
			for( int i = 0; i < (w*h); i++ ){
				int a = bitmapData[i];
				bitmapData[i] = (a&0xff00ff00)|((a>>16)&0xff)|((a<<16)&0xff0000);
			}
	
			//VRAMւ̓]pf[^쐬
			ByteBuffer buffer = ByteBuffer.allocateDirect(bitmapData.length * 4 );
			buffer.order(ByteOrder.nativeOrder());
			IntBuffer imageData = buffer.asIntBuffer();
			imageData.put( bitmapData );
			imageData.position(0);

			//VRAM֓]
			int[] no = new int[1]; 
			gl.glGenTextures( 1, no, 0 );
			gl.glBindTexture( GL10.GL_TEXTURE_2D, no[0] );
			/*
			 * 2008/12/1 C
			 * eNX`̐ݒ肪KvƂƂŁAȉ̐ݒǉBƂ肠ȉ̐ݒɂĂΖȂ
			 * ܂ȈӖ͈ȉ̂ƂB
			 * GL_TEXTURE_MIN_FILTER	:	eNX`k̏ݒ
			 * GL_TEXTURE_MAG_FILTER	:	eNX`g厞̏ݒ
			 * GL_TEXTURE_WRAP_S		:	c̃eNX`W1.0zۂ̏ݒ
			 * GL_TEXTURE_WRAP_T		:	̃eNX`W1.0zۂ̏ݒ
			 */
			gl.glTexParameterf(GL10.GL_TEXTURE_2D, GL10.GL_TEXTURE_MIN_FILTER, GL10.GL_LINEAR);
			gl.glTexParameterf(GL10.GL_TEXTURE_2D, GL10.GL_TEXTURE_MAG_FILTER, GL10.GL_LINEAR);
			gl.glTexParameterf(GL10.GL_TEXTURE_2D, GL10.GL_TEXTURE_WRAP_S, GL10.GL_REPEAT);
			gl.glTexParameterf(GL10.GL_TEXTURE_2D, GL10.GL_TEXTURE_WRAP_T, GL10.GL_REPEAT);
			gl.glTexImage2D( 
					GL10.GL_TEXTURE_2D, 0, GL10.GL_RGBA, w, h, 0, 
					GL10.GL_RGBA, GL10.GL_UNSIGNED_BYTE, imageData );
			//Ǘԍݒ
			textureNo = no[0];
			
			return true;
		}
	}
}
